# -*- coding: utf-8 -*-
"""BRRT_20250323_00.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1T3trnCxURfYmh1xgJVlrj5jik-cje_Ij

# BranchRouter
各アプリ起動用クラスオブジェクト取得辞書


```
2025/03/19 0.1.0 完成
2025/03/23 0.2.0 get_envs, get_managers 追加
```

# BranchRouter

## 1. モジュール定義
"""

# @title a. GDrive接続とcondacolab設定
if __name__ == '__main__':
    get_ipython().system( "pip install an_CondaInitializer" )
    from an_condainitializer import CondaInitializer

    condainitializer = CondaInitializer()

# @title b. BranchRouter 定義

get_ipython().system( "pip install an_debughelper" )
from an_debughelper import DebugHelper
get_ipython().system( "pip install an_envmanager" )
from an_envmanager import EnvManager
get_ipython().system( "pip install an_CudaUtility" )
from an_cudautility import CudaUtility
get_ipython().system( "pip install an_CondaManager" )
from an_condamanager import CondaManager
get_ipython().system( "pip install an_KohyaSetupManager" )
from an_kohyasetupmanager import KohyaSetupManager
get_ipython().system( "pip install an_DteSetupManager" )
from an_dtesetupmanager import DteSetupManager
get_ipython().system( "pip install an_ComfySetupManager" )
from an_comfysetupmanager import ComfySetupManager
get_ipython().system( "pip install an_SDSetupManager" )
from an_sdsetupmanager import SDSetupManager

class BranchRouter:
    def __init__(self):
        self.venv_dict = {
            "kohya_env": KohyaSetupManager,
            "dte_env": DteSetupManager,
            "comfy_env": ComfySetupManager,
            "sd_env": SDSetupManager
        }

    def get_envs( self ):
        return list(brrt.venv_dict.keys())

    def get_managers( self ):
        return list(brrt.venv_dict.values())

"""## 2. テスト"""

if __name__ == '__main__':
    brrt = BranchRouter()

    router_dte = brrt.venv_dict["dte_env"]()
    router_dte.run_setup()
    router_comfy = brrt.venv_dict["comfy_env"]()
    router_comfy.run_setup()
    router_sd = brrt.venv_dict["sd_env"]()
    router_sd.run_setup()
    router_kohya = brrt.venv_dict["kohya_env"]()
    # router_kohya.run_setup()
    # print( brrt.venv_dict( key[]))
    # venv_name = list(brrt.venv_dict.keys())[venv_no]
    # venv_instance = brrt.venv_dict[venv_name]()
    # venv_instance = list(brrt.venv_dict.values())[venv_no]() でもいい
    print( brrt.get_envs() )
    print( brrt.get_managers() )